﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace MusicLibrary
{
    public partial class NewSongDialog : Form
    {
        public Song Song { get; private set; }

        public NewSongDialog()
        {
            InitializeComponent();
        }

        private void nameTextBox_Validating(object sender, CancelEventArgs e)
        {
            if (nameTextBox.Text.Length == 0)
            {
                errorProvider.SetError(nameTextBox, "Name cannot be empty!");
                e.Cancel = true;
            }
            else
            {
                errorProvider.SetError(nameTextBox, null);
                e.Cancel = false;
            }
        }

        private void artistTextBox_Validating(object sender, CancelEventArgs e)
        {
            if (artistTextBox.Text.Length == 0)
            {
                errorProvider.SetError(artistTextBox, "Please specify an artist!");
                e.Cancel = true;
            }
            else
            {
                errorProvider.SetError(artistTextBox, null);
                e.Cancel = false;
            }
        }

        private void okButton_Click(object sender, EventArgs e)
        {
            if (ValidateChildren())
            {
                Song = new Song()
                    {
                        Name = nameTextBox.Text,
                        Artist = artistTextBox.Text,
                        Rating = (awfulRadioButton.Checked ? Rating.Awful : (alrightRadioButton.Checked ? Rating.Alright : (awesomeRadioButton.Checked ? Rating.Awesome : Rating.None)))
                    };

                DialogResult = DialogResult.OK;
                Close();
            }
        }

        private void cancelButton_Click(object sender, EventArgs e)
        {
            DialogResult = DialogResult.Cancel;
            Close();
        }
    }
}
